//    Copyright (C) 2022-2023 mirk0dex <mirkodi.eu>
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <https://www.gnu.org/licenses/>.

// strutils lib: a couple utils for string manipulation in C

#ifndef STRUTILS_H_
#define STRUTILS_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define CHARN 512 // max length of arrays

// convert int to string
char *itoa(long num) {
  char *result = malloc(CHARN);
  sprintf(result, "%ld", num);
  return result;
}

// flip char array (e.g.: "ABC" -> "CBA")
char *flip(char str[]) {
  int strLen = strlen(str), count = 0;
  char *flipped = malloc(strLen);
  for (int i = strLen - 1; i >= 0; --i)
    flipped[count++] = str[i];
  return flipped;
}

#endif // STRUTILS_H_
